/***************************************************************************
 *   Copyright (C) 2010 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "omconfig.h"

OMConfig::OMConfig(QString name, QWidget *parent)
 : QWidget(parent)
{

	Process = new QProcess( 0 );
	MainLayout = new QVBoxLayout();
	ButtonLayout = new QHBoxLayout();

	OKButton = new QPushButton(QObject::tr("ok"));
	ButtonLayout->addWidget(OKButton);
	connect(OKButton,SIGNAL(clicked()),this,SLOT(OKButtonclicked()));

	ApplyButton = new QPushButton(QObject::tr("apply"));
	ButtonLayout->addWidget(ApplyButton);
	connect(ApplyButton,SIGNAL(clicked()),this,SLOT(ApplyButtonclicked()));


	CancelButton = new QPushButton(QObject::tr("cancel"));
	ButtonLayout->addWidget(CancelButton);
	connect(CancelButton,SIGNAL(clicked()),this,SLOT(CancelButtonclicked()));

	settings = new QSettings("openmoko",name,this);

	PreEnableScript = new OMScriptWidget("Pre-enable-Script", settings, this) ;
	MainLayout->addWidget(PreEnableScript);
	PostEnableScript = new OMScriptWidget("Post-enable-Script", settings, this) ;
	MainLayout->addWidget(PostEnableScript);
	PreDisableScript = new OMScriptWidget("Pre-disable-Script", settings, this) ;
	MainLayout->addWidget(PreDisableScript);
	PostDisableScript = new OMScriptWidget("Post-disable-Script", settings, this) ;
	MainLayout->addWidget(PostDisableScript);

	MainLayout->addLayout(ButtonLayout);
	setLayout( MainLayout );
}


OMConfig::~OMConfig()
{
}




void OMConfig::OKButtonclicked()
{
    	ApplyButtonclicked();
	hide();
}


void OMConfig::ApplyButtonclicked()
{
    PreEnableScript->saveSettings();
    PostEnableScript->saveSettings();
    PreDisableScript->saveSettings();
    PostDisableScript->saveSettings();
}

void OMConfig::CancelButtonclicked()
{
    hide();
}


void OMConfig::runPreEnableScript()
{
    Process->start( PreEnableScript->script());
}

void OMConfig::runPostEnableScript()
{
    Process->start( PostEnableScript->script());
}

void OMConfig::runPreDisableScript()
{
    Process->start( PreDisableScript->script());
}

void OMConfig::runPostDisableScript()
{
    Process->start( PostDisableScript->script());
}
